﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Maps.MapControl;
using SLBingMobile.Utilities.Helpers;

namespace SLBingMobile.Utilities.CustomTileSource
{
    public class BingMapsMobileTileSource : TileSource
    {
        #region Properties

        public string MapDpiResolution { get; set; }
        public string MapStyle { get; set; }

        #endregion


        // http://ecn.t7.tiles.virtualearth.net/tiles/cmd/mobileTile?g=330&base=h&a=1&device=mobile&dpi=d1
        public BingMapsMobileTileSource()
            : base("http://ecn.t{2}.tiles.virtualearth.net/tiles/cmd/mobileTile?g=330&base={1}&a={0}&device=mobile&dpi={3}")
        {

        }

        #region TileSource specific methods

        public override Uri GetUri(int x, int y, int zoomLevel)
        {
            string quadKey = QuadKeyHelper.TileXYToQuadKey(x, y, zoomLevel);
            return new Uri(
                string.Format(
                    this.UriFormat, 
                    quadKey, 
                    this.MapStyle, 
                    (x % 7), 
                    this.MapDpiResolution
                )
            );
        }

        #endregion
    }
}
